module Colours where

data Colour = RGB Int Int Int
           deriving (Show, Eq)

red :: Colour -> Int
red (RGB r _ _) = r 

green :: Colour -> Int
green (RGB _ g _) = g

blue :: Colour -> Int
blue (RGB _ _ b) = b

{-
-- Definition des Datentypen mit Selektoren:
data Colour = RGB { red :: Int, green :: Int, blue :: Int }
     	    deriving (Eq, Show) 
-}
-- Some example colours

cyan :: Colour
cyan = RGB 0 255 255       -- 0x00FFFF

magenta :: Colour
magenta = RGB 255 0 255    -- 0xFF00FF

yellow :: Colour
yellow = RGB 255 255 0     -- 0xFFFF00

violet :: Colour
violet = RGB 238 130 238   -- 0xEE82EE

salmon :: Colour
salmon = RGB 250 128 114   -- 0xFA8072

goldenrod :: Colour
goldenrod = RGB 218 165 32 -- 0xDAA520
