--
-- "Zeichenketten selbstgemacht"
-- 
module String where

-- Vordefinierten Typen String und Funktionen verstecken
import Prelude hiding (String, length, (++), repeat, take, drop)

data String = Empty 
              | Char :+ String 
              deriving Eq

-- Nicer output
instance Show String where
  show Empty = ""
  show (c :+ s) = c: show s

-- Verkettung zweier Zeichenketten
(++) :: String-> String-> String
Empty ++ t  = t
(c :+ s) ++ t = c :+ (s++ t)

-- Laenge einer Zeichenkette
length :: String-> Int
length Empty    = 0
length (c :+ s) = 1+ length s      

-- Zeichenkette umkehren
rev :: String-> String
rev Empty    = Empty
rev (c :+ t) = rev t ++ (c :+ Empty)

-- Nochmal Palindrom
palin :: String-> Bool
palin s = s == rev s

-- Einen String n-mal wiederholen
repeat :: Int-> String-> String
repeat n s = if n == 0 then Empty
             else s ++ repeat (n-1) s


-- Die ersten n Zeichen der Zeichenkette
-- Voraussetzung: n >= 0
take :: Int-> String-> String
take n Empty = Empty
take n (c :+ s) = if n == 0 then Empty
                   else c :+ take (n-1) s

-- Die letzten n Zeichen der Zeichenkette
-- Voraussetzung: n >= 0
drop :: Int-> String-> String
drop n Empty      = Empty
drop n (c :+ s) = if n == 0 then c :+ s
                     else drop (n- 1) s
